#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivitySummerPlanGiftCFG.h"
std::auto_ptr<M_ActivitySummerPlanGiftCFG> M_ActivitySummerPlanGiftCFG::msSingleton(nullptr);

int M_ActivitySummerPlanGiftCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySummerPlanGiftCFGData* M_ActivitySummerPlanGiftCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivitySummerPlanGiftCFGData>& M_ActivitySummerPlanGiftCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySummerPlanGiftCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivitySummerPlanGiftCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySummerPlanGiftCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mNeedRecharged = element->IntAttribute("NeedRecharged");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivitySummerPlanGiftCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySummerPlanGiftCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivitySummerPlanGiftCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivitySummerPlanGiftCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivitySummerPlanGiftCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "NeedRecharged", data.mNeedRecharged);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivitySummerPlanGiftCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySummerPlanGiftCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivitySummerPlanGiftCFG* M_ActivitySummerPlanGiftCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySummerPlanGiftCFG());
	}
	return msSingleton.get();
}

void M_ActivitySummerPlanGiftCFG::Release()
{
	msSingleton.reset(nullptr);
}
